Index: trunk/NEMOGCM/NEMO/TOP_SRC/LOBSTER/sms_lobster.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/LOBSTER/sms_lobster.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/LOBSTER/sms_lobster.F90	(revision 2715)
@@ -4,27 +4,23 @@
    !! TOP :   LOBSTER 1 Source Minus Sink variables
    !!----------------------------------------------------------------------
-   !! History :    -   !  1999-09 (M. Levy)  original code
-   !!              -   !  2000-12 (O. Aumont, E. Kestenare) add sediment 
-   !!             1.0  !  2005-10 (C. Ethe) F90
-   !!             1.0  !  2005-03  (A-S Kremeur) add fphylab, fzoolab, fdetlab, fdbod
-   !!              -   !  2005-06  (A-S Kremeur) add sedpocb, sedpocn, sedpoca
-   !!             2.0  !  2007-04  (C. Deltel, G. Madec) Free form and modules
+   !! History :  OPA  !  1999-09  (M. Levy)  original code
+   !!             -   !  2000-12  (O. Aumont, E. Kestenare) add sediment 
+   !!   NEMO     1.0  !  2005-10  (C. Ethe) F90
+   !!             -   !  2005-03  (A-S Kremeur) add fphylab, fzoolab, fdetlab, fdbod
+   !!             -   !  2005-06  (A-S Kremeur) add sedpocb, sedpocn, sedpoca
+   !!            2.0  !  2007-04  (C. Deltel, G. Madec) Free form and modules
    !!----------------------------------------------------------------------
-
 #if defined key_lobster
    !!----------------------------------------------------------------------
    !!   'key_lobster'                                         LOBSTER model
    !!----------------------------------------------------------------------
-   USE par_oce
-   USE par_trc
+   USE par_oce    ! ocean parameters
+   USE par_trc    ! passive tracer parameters
+   USE lib_mpp    ! MPP library
 
    IMPLICIT NONE
    PUBLIC
 
-   !!----------------------------------------------------------------------
-   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
-   !! $Id$ 
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
-   !!----------------------------------------------------------------------
+   PUBLIC   sms_lobster_alloc   ! called in trcini_lobster.F90
 
    !!  biological parameters
@@ -76,19 +72,19 @@
    REAL(wp) ::   fdbod    !: zooplankton mortality fraction that goes to detritus
 
-   REAL(wp), DIMENSION(jpk,jp_lobster) ::   remdmp   !: depth dependant damping coefficient of passive tracers 
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) ::   remdmp   !: depth dependant damping coefficient of passive tracers 
    
    !! Optical parameters                                
    !! ------------------                                
-   REAL(wp) ::   xkr0       !: water coefficient absorption in red      (NAMELIST)
-   REAL(wp) ::   xkg0       !: water coefficient absorption in green    (NAMELIST)
-   REAL(wp) ::   xkrp       !: pigment coefficient absorption in red    (NAMELIST)
-   REAL(wp) ::   xkgp       !: pigment coefficient absorption in green  (NAMELIST)
-   REAL(wp) ::   xlr        !: exposant for pigment absorption in red   (NAMELIST)
-   REAL(wp) ::   xlg        !: exposant for pigment absorption in green (NAMELIST)
-   REAL(wp) ::   rpig       !: chla/chla+phea ratio                     (NAMELIST)
+   REAL(wp) ::   xkr0     !: water coefficient absorption in red      (NAMELIST)
+   REAL(wp) ::   xkg0     !: water coefficient absorption in green    (NAMELIST)
+   REAL(wp) ::   xkrp     !: pigment coefficient absorption in red    (NAMELIST)
+   REAL(wp) ::   xkgp     !: pigment coefficient absorption in green  (NAMELIST)
+   REAL(wp) ::   xlr      !: exposant for pigment absorption in red   (NAMELIST)
+   REAL(wp) ::   xlg      !: exposant for pigment absorption in green (NAMELIST)
+   REAL(wp) ::   rpig     !: chla/chla+phea ratio                     (NAMELIST)
                                                         
-   INTEGER , DIMENSION(jpi,jpj)     ::   neln    !: number of levels in the euphotic layer
-   REAL(wp), DIMENSION(jpi,jpj)     ::   xze     !: euphotic layer depth
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   xpar    !: par (photosynthetic available radiation)
+   INTEGER , ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   neln   !: number of levels in the euphotic layer
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   xze    !: euphotic layer depth
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   xpar   !: par (photosynthetic available radiation)
 
    !! Sediment parameters                               
@@ -98,13 +94,40 @@
    REAL(wp) ::   areacot      !: ???
                                                         
-   REAL(wp), DIMENSION(jpi,jpj)     ::   dminl   !: fraction of sinking POC released in sediments
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   dmin3   !: fraction of sinking POC released at each level
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   dminl     !: fraction of sinking POC released in sediments
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   dmin3     !: fraction of sinking POC released at each level
                                                         
-   REAL(wp), DIMENSION(jpi,jpj) ::   sedpocb     !: mass of POC in sediments
-   REAL(wp), DIMENSION(jpi,jpj) ::   sedpocn     !: mass of POC in sediments
-   REAL(wp), DIMENSION(jpi,jpj) ::   sedpoca     !: mass of POC in sediments
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   sedpocb   !: mass of POC in sediments
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   sedpocn   !: mass of POC in sediments
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   sedpoca   !: mass of POC in sediments
                                                         
-   REAL(wp), DIMENSION(jpi,jpj) ::   fbod        !: rapid sinking particles
-   REAL(wp), DIMENSION(jpi,jpj) ::   cmask       !: ???
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   fbod      !: rapid sinking particles
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   cmask     !: ???
+
+   !!----------------------------------------------------------------------
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
+   !! $Id$ 
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+CONTAINS
+
+   INTEGER FUNCTION sms_lobster_alloc()
+      !!----------------------------------------------------------------------
+      !!        *** ROUTINE sms_lobster_alloc ***
+      !!----------------------------------------------------------------------
+      !
+      ALLOCATE(                                                                   &
+         !*  Biological parameters
+         &      remdmp(jpk,jp_lobster)                                      ,     &
+         !*  Optical parameters
+         &      neln   (jpi,jpj) , xze    (jpi,jpj)     , xpar(jpi,jpj,jpk) ,     &
+         !*  Sediment parameters
+         &      dminl  (jpi,jpj) , dmin3  (jpi,jpj,jpk)                     ,     &
+         &      sedpocb(jpi,jpj) , sedpocn(jpi,jpj)     , sedpoca(jpi,jpj)  ,     &
+         &      fbod   (jpi,jpj) , cmask  (jpi,jpj)                         , STAT=sms_lobster_alloc ) 
+         !
+      IF( lk_mpp                 )   CALL mpp_sum ( sms_lobster_alloc )
+      IF( sms_lobster_alloc /= 0 )   CALL ctl_warn('sms_lobster_alloc: failed to allocate arrays')
+      !
+   END FUNCTION sms_lobster_alloc
 
 #else
Index: trunk/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcbio.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcbio.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcbio.F90	(revision 2715)
@@ -60,4 +60,7 @@
       !!              for passive tracers are saved for futher diagnostics.
       !!---------------------------------------------------------------------
+      USE wrk_nemo, ONLY: wrk_in_use,  wrk_not_released
+      USE wrk_nemo, ONLY: wrk_3d_2, wrk_4d_1
+      !!
       INTEGER, INTENT( in ) ::   kt      ! ocean time-step index      
       !!
@@ -75,10 +78,20 @@
 #endif
 #if defined key_diatrc && defined key_iomput
-      REAL(wp), DIMENSION(jpi,jpj,17)     :: zw2d
-      REAL(wp), DIMENSION(jpi,jpj,jpk,3) :: zw3d
+      REAL(wp), POINTER,   DIMENSION(:,:,:) :: zw2d
+      REAL(wp), POINTER, DIMENSION(:,:,:,:) :: zw3d
 #endif
       REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE ::   ztrbio
       CHARACTER (len=25) :: charout
       !!---------------------------------------------------------------------
+
+#if defined key_diatrc && defined key_iomput
+      IF( ( wrk_in_use(3, 2) ) .OR. ( wrk_in_use(4, 1) ) ) THEN
+         CALL ctl_stop('trc_bio : requested workspace arrays unavailable.')
+         RETURN
+      END IF
+      ! Set-up pointers into sub-arrays of workspaces
+      zw2d => wrk_3d_2(:,:,1:17)
+      zw3d => wrk_4d_1(:,:,:,1:3)
+#endif
 
       IF( kt == nit000 ) THEN
@@ -90,11 +103,12 @@
       fbod(:,:) = 0.e0
 #if defined key_diatrc && ! defined key_iomput
+#  if defined key_iomput
+      zw2d  (:,:,:) = 0.e0
+      zw3d(:,:,:,:) = 0.e0
+#  else
       DO jl = jp_lob0_2d, jp_lob1_2d
          trc2d(:,:,jl) = 0.e0
       END DO 
-#endif
-#if defined key_diatrc && defined key_iomput
-      zw2d(:,:,:) = 0.e0
-      zw3d(:,:,:,:) = 0.e0
+#  endif
 #endif
 
@@ -485,5 +499,10 @@
          CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm)
       ENDIF
-
+      !
+#if defined key_diatrc && defined key_iomput
+      IF( ( wrk_not_released(3, 2) ) .OR. ( wrk_not_released(4, 1) ) )  &
+        &   CALL ctl_stop('trc_bio : failed to release workspace arrays.')
+#endif
+      !
    END SUBROUTINE trc_bio
 
Index: trunk/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcexp.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcexp.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcexp.F90	(revision 2715)
@@ -101,5 +101,5 @@
             sedpoca(ji,jj) = ( zwork + dminl(ji,jj) * fbod(ji,jj)   &
                &           - sedlam * sedpocn(ji,jj) - sedlostpoc * sedpocn(ji,jj) ) * rdt
-            zgeolpoc = zgeolpoc + sedlostpoc * sedpocn(ji,jj) * e1t(ji,jj) * e2t(ji,jj)
+            zgeolpoc = zgeolpoc + sedlostpoc * sedpocn(ji,jj) * e1e2t(ji,jj)
          END DO
       END DO
Index: trunk/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcini_lobster.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcini_lobster.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcini_lobster.F90	(revision 2715)
@@ -4,7 +4,7 @@
    !! TOP :   initialisation of the LOBSTER biological model
    !!======================================================================
-   !! History :    -   !  1999-09  (M. Levy) Original code
+   !! History :   OPA  !  1999-09  (M. Levy) Original code
    !!              -   !  2000-12  (0. Aumont, E. Kestenare) add sediment 
-   !!             1.0  !  2004-03  (C. Ethe) Modularity
+   !!   NEMO      1.0  !  2004-03  (C. Ethe) Modularity
    !!              -   !  2005-03  (O. Aumont, A. El Moussaoui) F90
    !! History :   2.0  !  2007-12  (C. Ethe, G. Madec) from trcini.lobster1.h90
@@ -21,6 +21,4 @@
    USE trc
    USE lbclnk 
-   USE lib_mpp 
-   USE lib_fortran 
 
    IMPLICIT NONE
@@ -33,7 +31,6 @@
    !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
-   !!----------------------------------------------------------------------
-
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
@@ -43,13 +40,14 @@
       !! ** purpose :   specific initialisation for LOBSTER bio-model
       !!----------------------------------------------------------------------
+      USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
+      USE wrk_nemo, ONLY:   zrro => wrk_2d_1 , zdm0 => wrk_3d_1
+      !!
       INTEGER  ::   ji, jj, jk, jn
       REAL(wp) ::   ztest, zfluo, zfluu
-      REAL(wp), DIMENSION(jpi,jpj)     ::   zrro
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zdm0
       !!----------------------------------------------------------------------
-
-      !  Control consitency
-      CALL trc_ctl_lobster
-
+      !
+      IF(  wrk_in_use(2, 1)  .OR.  wrk_in_use(3, 1)  )  THEN
+         CALL ctl_stop('trc_ini_lobster: requested workspace arrays unavailable')   ;  RETURN
+      ENDIF
 
       IF(lwp) WRITE(numout,*)
@@ -57,8 +55,13 @@
       IF(lwp) WRITE(numout,*) ' ~~~~~~~~~~~~~~~'
 
+      !                                ! Allocate LOBSTER arrays
+      IF( sms_lobster_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'trc_ini_lobster: unable to allocate LOBSTER arrays' )
+
+
+
       ! initialization of fields for optical model
       ! --------------------------------------------
-      xze (:,:)   = 5.e0
-      xpar(:,:,:) = 0.e0
+      xze (:,:)   = 5._wp
+      xpar(:,:,:) = 0._wp
 
       ! initialization for passive tracer remineralisation-damping  array
@@ -70,7 +73,6 @@
 
       IF(lwp) THEN
-         WRITE(numout,*) ' '
-         WRITE(numout,*) ' trcini: compute remineralisation-damping  '
-         WRITE(numout,*) '         arrays for tracers'
+         WRITE(numout,*)
+         WRITE(numout,*) ' trcini: compute remineralisation-damping arrays for tracers'
       ENDIF
 
@@ -82,19 +84,19 @@
       ! ------------------------------------------------------------
 
-      zdm0   = 0.e0
-      zrro = 1.e0
-      DO jk = jpkb,jpkm1
-         DO jj =1, jpj
-            DO ji =1, jpi
+      zdm0 = 0._wp
+      zrro = 1._wp
+      DO jk = jpkb, jpkm1
+         DO jj = 1, jpj
+            DO ji = 1, jpi
                zfluo = ( fsdepw(ji,jj,jk  ) / fsdepw(ji,jj,jpkb) )**xhr 
                zfluu = ( fsdepw(ji,jj,jk+1) / fsdepw(ji,jj,jpkb) )**xhr
-               IF( zfluo.GT.1. )   zfluo = 1.e0
+               IF( zfluo.GT.1. )   zfluo = 1._wp
                zdm0(ji,jj,jk) = zfluo - zfluu
-               IF( jk <= jpkb-1 )   zdm0(ji,jj,jk) = 0.e0
+               IF( jk <= jpkb-1 )   zdm0(ji,jj,jk) = 0._wp
                zrro(ji,jj) = zrro(ji,jj) - zdm0(ji,jj,jk)
             END DO
          END DO
       END DO
-
+      !
       zdm0(:,:,jpk) = zrro(:,:)
 
@@ -103,12 +105,12 @@
       ! contains total fraction, which has passed to the upper layers)
       ! ----------------------------------------------------------------------
-      dminl = 0.
-      dmin3 = zdm0
+      dminl(:,:)   = 0._wp
+      dmin3(:,:,:) = zdm0
       DO jk = 1, jpk
          DO jj = 1, jpj
             DO ji = 1, jpi
-               IF( tmask(ji,jj,jk) == 0. ) THEN
+               IF( tmask(ji,jj,jk) == 0._wp ) THEN
                   dminl(ji,jj) = dminl(ji,jj) + dmin3(ji,jj,jk)
-                  dmin3(ji,jj,jk) = 0.e0
+                  dmin3(ji,jj,jk) = 0._wp
                ENDIF
             END DO
@@ -118,5 +120,5 @@
       DO jj = 1, jpj
          DO ji = 1, jpi
-            IF( tmask(ji,jj,1) == 0 )   dmin3(ji,jj,1) = 0.e0
+            IF( tmask(ji,jj,1) == 0 )   dmin3(ji,jj,1) = 0._wp
          END DO
       END DO
@@ -124,11 +126,11 @@
       ! Coastal mask 
       ! ------------   
-      cmask(:,:) = 0.e0
+      cmask(:,:) = 0._wp
       DO ji = 2, jpi-1
          DO jj = 2, jpj-1
-            if (tmask(ji,jj,1) == 1) then
+            IF( tmask(ji,jj,1) == 1._wp ) THEN
                ztest=tmask(ji+1,jj,1)*tmask(ji-1,jj,1)*tmask(ji,jj+1,1)*tmask(ji,jj-1,1)
-               IF (ztest == 0) cmask(ji,jj) = 1.
-            endif
+               IF( ztest == 0 )   cmask(ji,jj) = 1._wp
+            ENDIF
          END DO
       END DO
@@ -138,5 +140,5 @@
       ! Coastal surface
       ! ---------------
-      areacot = glob_sum( e1t(:,:) * e2t(:,:) * cmask(:,:) )
+      areacot = glob_sum( e1e2t(:,:) * cmask(:,:) )
 
       ! Initialization of tracer concentration in case of  no restart 
@@ -220,5 +222,6 @@
          trn(:,:,30,jp_lob_no3) = 20.01 * tmask(:,:,30)
 
-# elif defined key_gyre
+
+# elif defined key_gyre || defined key_orca_r2
          ! LOBSTER initialisation for GYRE
          ! ----------------------
@@ -245,76 +248,14 @@
 
       !  initialize the POC in sediments
-      sedpocb(:,:) = 0.e0
-      sedpocn(:,:) = 0.e0
-      sedpoca(:,:) = 0.e0
-
-
+      sedpocb(:,:) = 0._wp
+      sedpocn(:,:) = 0._wp
+      sedpoca(:,:) = 0._wp
+      !
       IF(lwp) WRITE(numout,*) 'Initialization of LOBSTER tracers done'
-      IF(lwp) WRITE(numout,*) ' '
-
-
+      !
+      IF(  wrk_not_released(2, 1)  .OR.   &
+           wrk_not_released(3, 1)   )   CALL ctl_stop('trc_ini_lobster: failed to release workspace arrays')
+      !
    END SUBROUTINE trc_ini_lobster
-
-   SUBROUTINE trc_ctl_lobster
-      !!----------------------------------------------------------------------
-      !!                     ***  ROUTINE trc_ctl_lobster  ***
-      !!
-      !! ** Purpose :   control the cpp options, namelist and files 
-      !!----------------------------------------------------------------------
-      INTEGER :: jl, jn
-
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) ' use LOBSTER biological model '
-
-      ! Check number of tracers
-      ! -----------------------
-      IF( jp_lobster /= 6 ) CALL ctl_stop( ' LOBSTER has 6 passive tracers. Change jp_lobster in par_lobster.F90' )
-
-      ! Check tracer names
-      ! ------------------
-      IF(   ctrcnm(jp_lob_det) /= 'DET' .OR. ctrcnm(jp_lob_zoo) /= 'ZOO' .OR.   &
-         &  ctrcnm(jp_lob_phy) /= 'PHY' .OR. ctrcnm(jp_lob_no3) /= 'NO3' .OR.   &
-         &  ctrcnm(jp_lob_nh4) /= 'NH4' .OR. ctrcnm(jp_lob_dom) /= 'DOM' .OR.   &
-         &  ctrcnl(jp_lob_det) /= 'Detritus'                        .OR.   &
-         &  ctrcnl(jp_lob_zoo) /= 'Zooplankton concentration'       .OR.   &
-         &  ctrcnl(jp_lob_phy) /= 'Phytoplankton concentration'     .OR.   &
-         &  ctrcnl(jp_lob_no3) /= 'Nitrate concentration'           .OR.   &
-         &  ctrcnl(jp_lob_nh4) /= 'Ammonium concentration'          .OR.   &
-         &  ctrcnl(jp_lob_dom) /= 'Dissolved organic matter' ) THEN
-         ctrcnm(jp_lob_det)='DET'
-         ctrcnl(jp_lob_det)='Detritus'
-         ctrcnm(jp_lob_zoo)='ZOO'
-         ctrcnl(jp_lob_zoo)='Zooplankton concentration'
-         ctrcnm(jp_lob_phy)='PHY'
-         ctrcnl(jp_lob_phy)='Phytoplankton concentration'
-         ctrcnm(jp_lob_no3)='NO3'
-         ctrcnl(jp_lob_no3)='Nitrate concentration'
-         ctrcnm(jp_lob_nh4)='NH4'
-         ctrcnl(jp_lob_nh4)='Ammonium concentration'
-         ctrcnm(jp_lob_dom)='DOM'
-         ctrcnl(jp_lob_dom)='Dissolved organic matter'
-         IF(lwp) THEN
-            CALL ctl_warn( ' We force tracer names ' )
-            DO jl = 1, jp_lobster
-               jn = jp_lob0 + jl - 1
-               WRITE(numout,*) ' tracer nb: ',jn,' name = ',ctrcnm(jn), ctrcnl(jn)
-            END DO
-            WRITE(numout,*) ' '
-         ENDIF
-      ENDIF
-
-      ! Check tracer units
-      DO jl = 1, jp_lobster
-         jn = jp_lob0 + jl - 1
-         IF( ctrcun(jn) /= 'mmole-N/m3') THEN
-            ctrcun(jn) = 'mmole-N/m3'
-            IF(lwp) THEN
-               CALL ctl_warn( ' We force tracer units ' )
-               WRITE(numout,*) ' tracer  ',ctrcnm(jn), 'UNIT= ',ctrcun(jn)
-            ENDIF
-         ENDIF
-      END DO
-
-   END SUBROUTINE trc_ctl_lobster
 
 #else
Index: trunk/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcnam_lobster.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcnam_lobster.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcnam_lobster.F90	(revision 2715)
@@ -10,11 +10,10 @@
    !!   'key_lobster'   :                                 LOBSTER bio-model
    !!----------------------------------------------------------------------
-   !! trc_nam_lobster      : LOBSTER model namelist read
-   !!----------------------------------------------------------------------
-   USE oce_trc         ! Ocean variables
-   USE par_trc         ! TOP parameters
-   USE trc             ! TOP variables
-   USE sms_lobster     ! sms trends
-   USE in_out_manager  ! I/O manager
+   !! trc_nam_lobster   : LOBSTER model namelist read
+   !!----------------------------------------------------------------------
+   USE oce_trc          ! Ocean variables
+   USE par_trc          ! TOP parameters
+   USE trc              ! TOP variables
+   USE sms_lobster      ! sms trends
 
    IMPLICIT NONE
Index: trunk/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcopt.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcopt.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcopt.F90	(revision 2715)
@@ -52,4 +52,10 @@
       !!                xze    ???
       !!---------------------------------------------------------------------
+      USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
+      USE wrk_nemo, ONLY: zpar100 => wrk_2d_1, & ! irradiance at euphotic layer depth
+                          zpar0m  => wrk_2d_2    ! irradiance just below the surface
+      USE wrk_nemo, ONLY: zparr => wrk_3d_2, &   ! red and green compound of par
+                          zparg => wrk_3d_3
+      !!
       INTEGER, INTENT( in ) ::   kt   ! index of the time stepping
       !!
@@ -59,9 +65,10 @@
       REAL(wp) ::   zkr, zkg            ! total absorption coefficient in red and green
       REAL(wp) ::   zcoef               ! temporary scalar
-      REAL(wp), DIMENSION(jpi,jpj)     ::   zpar100         ! irradiance at euphotic layer depth
-      REAL(wp), DIMENSION(jpi,jpj)     ::   zpar0m          ! irradiance just below the surface
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zparr, zparg    ! red and green compound of par
 
       !!---------------------------------------------------------------------
+
+      IF( ( wrk_in_use(2, 1,2)) .OR. ( wrk_in_use(3, 2,3)) )THEN
+         CALL ctl_stop('trc_opt : requested workspace arrays unavailable')   ;   RETURN
+      END IF
 
       IF( kt == nit000 ) THEN
@@ -130,4 +137,7 @@
       ENDIF
       !
+      IF( wrk_not_released(2, 1,2)  .OR.  wrk_not_released(3, 2,3)  )   &
+          CALL ctl_stop('trc_opt : failed to release workspace arrays')
+      !
    END SUBROUTINE trc_opt
 
Index: trunk/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcrst_lobster.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcrst_lobster.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcrst_lobster.F90	(revision 2715)
@@ -18,5 +18,4 @@
    USE trcsms_lobster          ! lobster sms trends
    USE sms_lobster          ! lobster sms trends
-   USE in_out_manager  ! I/O manager
    USE iom
 
Index: trunk/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcsed.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcsed.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcsed.F90	(revision 2715)
@@ -56,15 +56,21 @@
       !!              trend of passive tracers is saved for futher diagnostics.
       !!---------------------------------------------------------------------
+      USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
+      USE wrk_nemo, ONLY: zwork => wrk_3d_2
+      USE wrk_nemo, ONLY: zw2d  => wrk_2d_1 ! only used (if defined 
+                                            ! key_diatrc && defined key_iomput)
+      !!
       INTEGER, INTENT( in ) ::   kt      ! ocean time-step index      
       !!
       INTEGER  ::   ji, jj, jk, jl
       REAL(wp) ::   ztra
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zwork
-#if defined key_diatrc && defined key_iomput
-      REAL(wp), DIMENSION(jpi,jpj) ::  zw2d
-#endif
       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::   ztrbio
       CHARACTER (len=25) :: charout
       !!---------------------------------------------------------------------
+
+      IF( ( wrk_in_use(3,2)) .OR. ( wrk_in_use(2,1)) ) THEN
+         CALL ctl_stop('trc_sed : requested workspace arrays unavailable.')
+         RETURN
+      END IF
 
       IF( kt == nit000 ) THEN
@@ -144,4 +150,7 @@
       ENDIF
 
+      IF( ( wrk_not_released(3, 2) ) .OR. ( wrk_not_released(2, 1) ) )  &
+       &         CALL ctl_stop('trc_sed : failed to release workspace arrays.')
+
    END SUBROUTINE trc_sed
 
Index: trunk/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcsms_lobster.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcsms_lobster.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/LOBSTER/trcsms_lobster.F90	(revision 2715)
@@ -13,5 +13,5 @@
    !!   trcsms_lobster        :  Time loop of passive tracers sms
    !!----------------------------------------------------------------------
-   USE oce_trc         !
+   USE oce_trc          !
    USE trc
    USE trcbio
@@ -32,7 +32,6 @@
    !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
 CONTAINS
 
@@ -45,9 +44,15 @@
       !!
       !! ** Method  : - ???
-      !! -------------------------------------------------------------------------------------
+      !! --------------------------------------------------------------------
+      USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
+      USE wrk_nemo, ONLY: ztrlob => wrk_3d_1   ! used for lobster sms trends
+      !!
       INTEGER, INTENT( in ) ::   kt      ! ocean time-step index      
       INTEGER :: jn
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   ztrlob   ! used for lobster sms trends
-      !!
+      !! --------------------------------------------------------------------
+
+      IF( wrk_in_use(3, 1) ) THEN
+         CALL ctl_stop('trc_sms_lobster : requested workspace array unavailable')   ;   RETURN
+      ENDIF
 
       CALL trc_opt( kt )      ! optical model
@@ -65,4 +70,6 @@
       IF( lk_trdmld_trc )  CALL trd_mld_bio( kt )   ! trends: Mixed-layer
 
+      IF( wrk_not_released(3, 1) )   CALL ctl_stop('trc_sms_lobster : failed to release workspace array.')
+      !
    END SUBROUTINE trc_sms_lobster
 
Index: trunk/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcini_my_trc.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcini_my_trc.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcini_my_trc.F90	(revision 2715)
@@ -24,7 +24,6 @@
    !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
 CONTAINS
 
@@ -38,6 +37,8 @@
       !!----------------------------------------------------------------------
 
-      !  Control consitency
-      CALL trc_ctl_my_trc
+      !                       ! Allocate MY_TRC arrays
+      IF( sms_lobster_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'trc_ini_my_trc: unable to allocate MY_TRC arrays' )
+
+      CALL trc_ctl_my_trc     ! Control consitency
 
       IF(lwp) WRITE(numout,*)
@@ -46,8 +47,8 @@
       
       IF( .NOT. ln_rsttr ) trn(:,:,:,jp_myt0:jp_myt1) = 0.
-
       !
    END SUBROUTINE trc_ini_my_trc
-   
+
+
    SUBROUTINE trc_ctl_my_trc
       !!----------------------------------------------------------------------
@@ -56,18 +57,17 @@
       !! ** Purpose :   control the cpp options, namelist and files 
       !!----------------------------------------------------------------------
-
       INTEGER :: jl, jn
-
+      !!----------------------------------------------------------------------
+      !
       IF(lwp) WRITE(numout,*)
       IF(lwp) WRITE(numout,*) ' use COLOR tracer '
-
+      !
       DO jl = 1, jp_my_trc
          jn = jp_myt0 + jl - 1
-         WRITE(ctrcnm(jn),'(a,i2.2)') 'CLR',jn
+         WRITE( ctrcnm(jn),'(a,i2.2)' ) 'CLR', jn
          ctrcnl(jn)='Color concentration'
          ctrcun(jn)='N/A'
       END DO
-
-
+      !
    END SUBROUTINE trc_ctl_my_trc
 
Index: trunk/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcsms_my_trc.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcsms_my_trc.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcsms_my_trc.F90	(revision 2715)
@@ -10,5 +10,6 @@
    !!   'key_my_trc'                                               CFC tracers
    !!----------------------------------------------------------------------
-   !! trc_sms_my_trc   : MY_TRC model main routine 
+   !! trc_sms_my_trc       : MY_TRC model main routine 
+   !! trc_sms_my_trc_alloc : allocate arrays specific to MY_TRC sms
    !!----------------------------------------------------------------------
    USE par_trc         ! TOP parameters
@@ -21,12 +22,14 @@
    PRIVATE
 
-   PUBLIC   trc_sms_my_trc   ! called by trcsms.F90 module
+   PUBLIC   trc_sms_my_trc       ! called by trcsms.F90 module
+   PUBLIC   trc_sms_my_trc_alloc ! called by trcini_my_trc.F90 module
 
+   ! Defined HERE the arrays specific to MY_TRC sms and ALLOCATE them in trc_sms_my_trc_alloc
+   
    !!----------------------------------------------------------------------
    !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
 CONTAINS
 
@@ -39,8 +42,10 @@
       !! ** Method  : - 
       !!----------------------------------------------------------------------
-      INTEGER, INTENT(in) :: kt   ! ocean time-step index
-      REAL(wp), DIMENSION(jpi,jpj,jpk)    ::   ztrmyt 
-      INTEGER :: jn
-
+      USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
+      USE wrk_nemo, ONLY:   ztrmyt => wrk_3d_1   ! used for lobster sms trends
+      !
+      INTEGER, INTENT(in) ::   kt   ! ocean time-step index
+      INTEGER ::   jn   ! dummy loop index
+      !!----------------------------------------------------------------------
 
       IF(lwp) WRITE(numout,*)
@@ -49,17 +54,16 @@
 
       WHERE( (glamt <= 170) .AND. (glamt >= 160) .AND. (gphit <= -74) .AND. (gphit >=-75.6) )
-        trn(:,:,1,jpmyt1) = 1.
-        trb(:,:,1,jpmyt1) = 1.
-        tra(:,:,1,jpmyt1) = 0.
+        trn(:,:,1,jpmyt1) = 1._wp
+        trb(:,:,1,jpmyt1) = 1._wp
+        tra(:,:,1,jpmyt1) = 0._wp
       END WHERE
 
       WHERE( ((glamt <= -165) .OR. (glamt >= 160)) .AND. (gphit <= -76) .AND. (gphit >=-80)) 
-        trn(:,:,1,jpmyt2) = 1.
-        trb(:,:,1,jpmyt2) = 1.
-        tra(:,:,1,jpmyt2) = 0.
+        trn(:,:,1,jpmyt2) = 1._wp
+        trb(:,:,1,jpmyt2) = 1._wp
+        tra(:,:,1,jpmyt2) = 0._wp
       END WHERE
 
-      ! Save the trends in the ixed layer
-      IF( l_trdtrc ) THEN
+      IF( l_trdtrc ) THEN      ! Save the trends in the ixed layer
           DO jn = jp_myt0, jp_myt1
             ztrmyt(:,:,:) = tra(:,:,:,jn)
@@ -69,5 +73,20 @@
       !
    END SUBROUTINE trc_sms_my_trc
-   
+
+
+   INTEGER FUNCTION trc_sms_my_trc_alloc()
+      !!----------------------------------------------------------------------
+      !!              ***  ROUTINE trc_sms_my_trc_alloc  ***
+      !!----------------------------------------------------------------------
+      !
+      ! ALLOCATE here the arrays specific to MY_TRC
+      ! ALLOCATE( tab(...) , STAT=trc_sms_my_trc_alloc )
+      trc_sms_my_trc_alloc = 0      ! set to zero if no array to be allocated
+      !
+      IF( trc_sms_my_trc_alloc /= 0 ) CALL ctl_warn('trc_sms_my_trc_alloc : failed to allocate arrays')
+      !
+   END FUNCTION trc_sms_my_trc_alloc
+
+
 #else
    !!----------------------------------------------------------------------
